/**
 * Extension namespace.
 */
if (typeof(HTTPSDiskCacheController) == "undefined") {
  var HTTPSDiskCacheController = {};
};

HTTPSDiskCacheController.BrowserOverlay = {
  init: function() {
    let firstRunPref = "extensions.httpsDiskCacheController.first_run_done";
    //this.pref.deleteBranch(firstRunPref); // XXX remove when you package

    if (!this.pref.prefHasUserValue(firstRunPref)) {// || 
                    //!this.pref.getBoolPref(firstRunPref)) {
      this.pref.setBoolPref(firstRunPref, true);
      this.pref.setBoolPref("browser.cache.disk_cache_ssl", false);

      installButton("nav-bar", "httpsdcc-button");
      // The "addon-bar" is available since Firefox 4
      installButton("addon-bar", "httpsdcc-button");
    }
    this.update_icon();
  },

  toggle: function(aEvent) {
    let value = !this.pref.getBoolPref("browser.cache.disk_cache_ssl");
    this.pref.setBoolPref("browser.cache.disk_cache_ssl", value);

    this.update_icon();
  },

  update_icon: function() {
    let button = document.getElementById("httpsdcc-button");
    let state = this.pref.getBoolPref("browser.cache.disk_cache_ssl");
    let stringBundle = document.getElementById("httpsdcc-string-bundle");

    button.style.listStyleImage = 'url(chrome://httpsdcc/skin/' 
        + (state ? 'off.png' : 'on.png') + ')';
    button.setAttribute("tooltiptext", stringBundle.getString(
        "httpsdcc.toolbar.button.tooltip." + (state ? "off" : "on")));
  },

  pref: Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefService)
                    .getBranch("")
};

/**
 * Code from: https://developer.mozilla.org/en-US/docs/Code_snippets/Toolbar?redirectlocale=en-US&redirectslug=Code_snippets%3AToolbar#Adding_button_by_default
 * Installs the toolbar button with the given ID into the given
 * toolbar, if it is not already present in the document.
 *
 * @param {string} toolbarId The ID of the toolbar to install to.
 * @param {string} id The ID of the button to install.
 * @param {string} afterId The ID of the element to insert after. @optional
 */
function installButton(toolbarId, id, afterId) {
    if (!document.getElementById(id)) {
        var toolbar = document.getElementById(toolbarId);
 
        // If no afterId is given, then append the item to the toolbar
        var before = null;
        if (afterId) {
            let elem = document.getElementById(afterId);
            if (elem && elem.parentNode == toolbar)
                before = elem.nextElementSibling;
        }
 
        toolbar.insertItem(id, before);
        toolbar.setAttribute("currentset", toolbar.currentSet);
        document.persist(toolbar.id, "currentset");
 
        if (toolbarId == "addon-bar")
            toolbar.collapsed = false;
    }
}
window.addEventListener(
  "load", function() { HTTPSDiskCacheController.BrowserOverlay.init(); }, false);
